Codeforces Round #307 (Div. 2) B. ZgukistringZ

Professor GukiZ doesn‘t accept string as they are. He likes to swap some letters in string to obtain a new one.

GukiZ has strings ab,
and c. He wants to obtain string k by
swapping some letters in a, so that k should
contain as many non-overlapping substrings equal either to b or c as
possible. Substring of string x is a string formed by consecutive segment of characters from x.
Two substrings of string x overlap if there is position i in
string x occupied by both of them.

GukiZ was disappointed because none of his students managed to solve the problem. Can you help them and find one of possible strings k?

Input

The first line contains string a, the second line contains string b,
and the third line contains string c (1?≤?|a|,?|b|,?|c|?≤?105,
where |s|denotes the length of string s).

All three strings consist only of lowercase English letters.

It is possible that b and c coincide.

Output

Find one of possible strings k, as described in the problem statement. If there are multiple possible answers, print any of them.

Sample test(s)

input

aaa
a
b

output

aaa

input

pozdravstaklenidodiri
niste
dobri

output

nisteaadddiiklooprrvz

input

abbbaaccca
ab
aca

output

ababacabcc

Note

In the third sample, this optimal solutions has three non-overlaping substrings equal to either b or c on
positions 1?–?2 (ab), 3?–?4 (ab),5?–?7 (aca).
In this sample, there exist many other optimal solutions, one of them would be acaababbcc.

这题因为字母可以随意调换,所以先数出a,b,c三个字符串所有字母表中的字母的个数,然后看最多能填充多少个b字符串minx,然后填充0~minx个字符串,再看在当前情况下能填充多少个c字符串,计算最大值。

#include<stdio.h>
#include<string.h>
char s1[100006],s2[100006],s3[100006];
int a[30],b[30],c[30],a1[30];
int main()
{
	int n,m,i,j,len1,len2,len3,minx1,minx2,maxx,minx,t1,t2;
	while(scanf("%s",s1)!=EOF)
	{
		scanf("%s%s",s2,s3);
		len1=strlen(s1);
		len2=strlen(s2);len3=strlen(s3);
		memset(a,0,sizeof(a));memset(b,0,sizeof(b));memset(c,0,sizeof(c));memset(a1,0,sizeof(a1));
		for(i=0;i<len1;i++){
			a[s1[i]-'a']++;a1[s1[i]-'a']++;
		}
		for(i=0;i<len2;i++){
			b[s2[i]-'a']++;
		}
		for(i=0;i<len3;i++){
			c[s3[i]-'a']++;
		}
		minx1=200006;
		for(i=0;i<=25;i++){
			if(b[i]==0)continue;
			if(minx1>(a[i]/b[i]))minx1=a[i]/b[i];
		}
		minx2=200006;
		for(i=0;i<=25;i++){
			if(c[i]==0)continue;
			if(minx2>(a[i]/c[i]))minx2=a[i]/c[i];
		}
		maxx=minx2;t1=0;t2=minx2;
		for(i=1;i<=minx1;i++){
			minx=200006;
			for(j=0;j<=25;j++){
				a[j]-=b[j];
			}
			for(j=0;j<=25;j++){
				if(c[j]==0)continue;
				if(minx>(a[j]/c[j]))minx=a[j]/c[j];
			}
			if(maxx<minx+i){
				maxx=minx+i;
				t1=i;t2=minx;
			}
		}
		for(i=1;i<=t1;i++)printf("%s",s2);
		for(i=1;i<=t2;i++)printf("%s",s3);
		for(i=0;i<=25;i++){
			a1[i]=a1[i]-t1*b[i]-t2*c[i];
			for(j=1;j<=a1[i];j++){
				printf("%c",'a'+i);
			}
		}
		printf("\n");
	}
	return 0;
}
时间: 2024-07-31 20:08:50

Codeforces Round #307 (Div. 2) B. ZgukistringZ的相关文章

字符串处理/贪心 Codeforces Round #307 (Div. 2) B. ZgukistringZ

题目传送门 1 /* 2 题意:任意排列第一个字符串,使得有最多的不覆盖a/b字符串出现 3 字符串处理/贪心:暴力找到最大能不覆盖的a字符串,然后在b字符串中动态得出最优解 4 恶心死我了,我最初想输出最多的a,再最多的b,然而并不能保证是最多的:( 5 */ 6 #include <cstdio> 7 #include <cstring> 8 #include <string> 9 #include <iostream> 10 #include <

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f

Codeforces Round #315 (Div. 1)

A. Primes or Palindromes? time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Rikhail Mubinchik believes that the current definition of prime numbers is obsolete as they are too complex and un